﻿using MediatR;
using System;
using System.Threading;
using System.Threading.Tasks;

namespace Correo.Application.Queries
{
    public class GetSystemVersion
    {
        public record Query : IRequest<Model>
        {
        }

        public record Model
        {
            public string Version { get; init; }
            public DateTime LastUpdateDate { get; init; }
        }

        public class QueryHandler : IRequestHandler<Query, Model>
        {
            public QueryHandler()
            {
            }

            public async Task<Model> Handle(Query request, CancellationToken cancellationToken)
            {
                var result = new Model()
                {
                    Version = "1.0.0",
                    LastUpdateDate = DateTime.Now
                };

                return await Task.FromResult(result);
            }
        }
    }
}
